/*
 * Wazuh app - Base query for reporting queries
 * Copyright (C) 2015-2020 Wazuh, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Find more information about this on the LICENSE file.
 */
export function Base(pattern, filters, gte, lte) {
  return {
    pattern: pattern,
    from: 0,
    size: 500,
    aggs: {},
    sort: [],
    script_fields: {},
    query: {
      bool: {
        must: [
          {
            query_string: {
              query: filters,
              analyze_wildcard: true,
              default_field: '*'
            }
          },
          {
            range: {
              timestamp: {
                gte: gte,
                lte: lte,
                format: 'epoch_millis'
              }
            }
          }
        ],
        must_not: []
      }
    }
  };
}
